SOCKETPAIR(2)

NAME
socketpair - create a pair of connected sockets

LIBRARY
libc

SYNOPSIS
#include <sys/types.h>
#include <sys/socket.h>
int
socketpair(int domain, int type, int protocol, int *sv);

DESCRIPTION
The socketpair() system call creates an unnamed pair of connected sockets in the specified communications domain, of the specified type, and using the optionally specified protocol. The descriptors used in referencing the new sockets are returned in sv[0] and sv[1]. The two sockets are indistinguishable.

The SOCK_CLOEXEC, SOCK_CLOFORK and SOCK_NONBLOCK flags in the type argument apply to both descriptors.

RETURN VALUES

ERRORS
The call succeeds unless:

[EMFILE]
    Too many descriptors are in use by this process.

[EAFNOSUPPORT]
    The specified address family is not supported on this machine.

[EPROTONOSUPPORT]
    The specified protocol is not supported on this machine.

[EOPNOTSUPP]
    The specified protocol does not support creation of socket pairs.

[EFAULT]
    The address sv does not specify a valid part of the process address space.

SEE ALSO
pipe(2), read(2), socket(2), write(2)

STANDARDS
The socketpair() system call conforms to p1003.1-2001 and p1003.1-2008.

HISTORY
The socketpair() system call appeared in 4.2BSD.

BUGS
This call is currently implemented only for the UNIX domain.